plugins['presencepause'] = (function() {

    return { 

        loadLang: function(values) {
        },
        setLang: function() {
        },
        init: function() {
            if(
                (!hasPerm(0,'queuepause') && !hasPerm(0,'queueagent') && !hasPerm(0,'queuemanager') && !hasPerm(0,'all')) &&
                (!hasPerm(myposition,'queuepause') && !hasPerm(myposition,'queueagent') && !hasPerm(myposition,'queuemanager') && !hasPerm(myposition,'all')) 
            ) {
                console.warn('Disabling presence pause due to lack of permissions');
                $('.navinputpresence').hide();
            } else {
                $('.navinputpresence').show();
            }
        },
        callback_queuemember: function(nro,texto,slot) {
            let agent_channels = {}
            let all_channels = {};
            botonitos[myposition].QUEUECHANNEL.split('&').forEach(function(el) { agent_channels[el.split('|')[0]]=1;});
            Object.entries(queuesismember).forEach(function(el) { el[1].forEach( function(al){ all_channels[al]=1})});
            if(plugins['presencepause'].checkIntersect(agent_channels,all_channels)) {
                $('#presence').removeAttr('disabled');
                $('#presence.selectpicker').selectpicker('refresh');
            } else {
                $('#presence').attr('disabled','disabled');
                $('#presence.selectpicker').selectpicker('refresh');
            }
        },
        callback_queuemembers: function(nro,texto,slot) {
            let agent_channels = {}
            let all_channels = {};
            botonitos[myposition].QUEUECHANNEL.split('&').forEach(function(el) { agent_channels[el.split('|')[0]]=1;});
            Object.entries(queuesismember).forEach(function(el) { el[1].forEach( function(al){ all_channels[al]=1})});
            if(plugins['presencepause'].checkIntersect(agent_channels,all_channels)) {
                $('#presence').removeAttr('disabled');
                $('#presence.selectpicker').selectpicker('refresh');
            } else {
                $('#presence').attr('disabled','disabled');
                $('#presence.selectpicker').selectpicker('refresh');
            }
        },
        callback_notionline: function(nro,texto,slot) {
            if(availablequeues.length==0) {
                $('.navinputpresence').hide();
            } else {
                $('.navinputpresence').show();
            }
        },
        checkIntersect: function(object1,object2) {
            for (let key in object1) {
                if (object2.hasOwnProperty(key)) {
                    return true;
                }
            }
            return false;
        }
    }
}());
